/* 

    >>> errorhandling <<<

    ERR(no)	   no: 0=no error (print status)
    			>=9000	FATAL=exit
 
*/

#ifndef ERROR_HANDLING	/* define once only */
#define ERROR_HANDLING
/* #include "sighand.h" */

/* the error caller should be only little code, dont waste cache */
#define ERR(no)  err_pg(no,__LINE__,__FILE__) /* 6 x86asm-cmds */

extern int err_fatal;	/* for communication between functions */
extern int vvv;		/* verbose-mode 1=outx, 2=mem+outhxy, 4=eigenvals,
                                        8=sym, 16=diskIO, 32=Hij, 64=base,
                                        128=ini_n2  */

void err_pg(int no, const int line, const char *file); /* 4Byte x86asm? */

/* -----------------------------------------------------------------
    wie geht man am besten mit Fehlern um? 
    es ist nicht immer sinnvoll, sofort exit(1) auszufuehren 
    globale error_line etc. variablen
    z.B. Wdhl. merken aber nur 1.,2., und letzte Meldung ausgeben
    diese Variante erzeugt viel exe-code (belastet cache?)
   ----------------------------------------------------------------- */
#define IFNAN(r,x)	{if(isnan(r)!=0){ERR(1);printf(x"=%g\n",r);}}
#define E0(s1)		{printf("\nERROR "s1);ERR(1);}
#define E1(s1,a1)	{printf("\nERROR "s1,a1);ERR(1);}
#define E2(s1,a1,a2)	{printf("\nERROR "s1,a1,a2);ERR(1);}
#define E3(s1,a1,a2,a3)	{printf("\nERROR "s1,a1,a2,a3);ERR(1);}
#define F0(s1)		{printf("\nFATAL "s1);ERR(9999);}
#define F1(s1,a1)	{printf("\nFATAL "s1,a1);ERR(9999);}
#define F2(s1,a1,a2)	{printf("\nFATAL "s1,a1,a2);ERR(9999);}
#define F3(s1,a1,a2,a3)	{printf("\nFATAL "s1,a1,a2,a3);ERR(9999);}
#endif	/* -------------------- end-error ---------------------------- */
